P365/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.urls import include, path
from django.contrib import admin
from django.contrib.auth.views import logout_then_login

import calendar_year.urls
import profile.urls
import story.urls
import table.urls
import tag.urls
from map import urls_map, urls_poi, urls_route, urls_track
from profile.views import LoginView, ProfileRedirect, SignUpView, IndexView

urlpatterns = [
    # main
    path('',            IndexView.as_view(),        name='index'),
    path('admin/',      admin.site.urls,),
    path('summernote/', include('django_summernote.urls')),
    # auth
    path('login/',      LoginView.as_view(),        name='login'),
    path('register/',   SignUpView.as_view(),       name='signup'),
    path('logout/',     logout_then_login,          name='logout'),
    # redirection
    path('accounts/profile/', ProfileRedirect.as_view()),
    # tabs
    path('calendar/',   include(calendar_year.urls, namespace='calendar')),
    path('map/',        include(urls_map,           namespace='map')),
    path('table/',      include(table.urls,         namespace='table')),
    path('story/',      include(story.urls,         namespace='story')),
    # other
    path('user/',       include(profile.urls,       namespace='user')),
    path('poi/',        include(urls_poi,           namespace='poi')),
    path('route/',      include(urls_route,         namespace='route')),
    path('track/',      include(urls_track,         namespace='track')),
    path('tag/',        include(tag.urls,           namespace='tag')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

story/urls.py
from django.urls import path, register_converter

from P365.converters import UintWithoutZero
from .views import StoriesView, StoryView, StoryEditView, JSONStoryDeleteView

app_name = 'story'

register_converter(UintWithoutZero, 'uint_id')

urlpatterns = [
    path('',                          StoriesView.as_view(),         name='stories'),
    path('<uint_id:id>/',             StoryView.as_view(),           name='view'),
    path('<uint_id:id>/edit/',        StoryEditView.as_view(),       name='edit'),
    path('<uint_id:id>/json_delete/', JSONStoryDeleteView.as_view(), name='json_delete'),
    path('create/',                   StoryEditView.as_view(),       name='create'),
]

tag/urls.py
from django.urls import path

from .views import TagCloudView, TagView

app_name = 'tag'

urlpatterns = [
    path('',                TagCloudView.as_view(), name='tag_cloud'),
    path('<slug:tagslug>/', TagView.as_view(),      name='tag'),
]

map/models.py
from django.contrib.auth.models import User
from django.contrib.gis.db import models
from taggit.managers import TaggableManager

from P365.settings import MAX_LENGTH


class POIModel(models.Model):
    # Basic
    name = models.CharField(max_length=MAX_LENGTH['name'])
    description = models.TextField(max_length=MAX_LENGTH['description'], null=True, blank=True)
    # Relations
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    tags = TaggableManager(blank=True)
    # Datetime
    created = models.DateTimeField(auto_now_add=True)
    # Flags
    public = models.BooleanField(default=False)
    is_active = models.BooleanField(default=True)
    # Feature
    geom = models.PointField(dim=3)

    objects = models.Manager()

    def __str__(self):
        return self.name

    @property
    def longitude(self):
        return self.geom.x

    @property
    def latitude(self):
        return self.geom.y

    @property
    def altitude(self):
        return self.geom.z


class RouteModel(models.Model):
    # Basic
    name = models.CharField(max_length=MAX_LENGTH['name'])
    description = models.TextField(max_length=MAX_LENGTH['description'], null=True, blank=True)
    # Relations
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    tags = TaggableManager(blank=True)
    # Datetime
    created = models.DateTimeField(auto_now_add=True)
    # Distance
    length = models.FloatField(default=0)
    # Altitudes
    altitude_gain = models.FloatField(default=0)
    altitude_loss = models.FloatField(default=0)
    altitude_max = models.FloatField(default=0)
    altitude_min = models.FloatField(default=0)
    # Flags
    public = models.BooleanField(default=False)
    is_active = models.BooleanField(default=True)
    # Feature
    geom = models.LineStringField(dim=3)

    objects = models.Manager()

    def __str__(self):
        return self.name


class TrackModel(models.Model):
    # Basic
    name = models.CharField(max_length=MAX_LENGTH['name'])
    description = models.TextField(max_length=MAX_LENGTH['description'], null=True, blank=True)
    # Relations
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    tags = TaggableManager(blank=True)
    # Datetime
    created = models.DateTimeField(auto_now_add=True)
    start_date = models.DateTimeField()
    finish_date = models.DateTimeField()
    # Distance
    length = models.FloatField(default=0)
    # Speed
    speed = models.FloatField(default=0)
    speed_max = models.FloatField(default=0)
    # Altitudes
    altitude_gain = models.FloatField(default=0)
    altitude_loss = models.FloatField(default=0)
    altitude_max = models.FloatField(default=0)
    altitude_min = models.FloatField(default=0)
    # Flags
    public = models.BooleanField(default=False)
    is_active = models.BooleanField(default=True)
    # Feature
    geom = models.MultiLineStringField(dim=3)

    objects = models.Manager()

    def __str__(self):
        return self.name

map/forms.py
from django.contrib.gis.geos import Point, LineString
from django.forms import ModelForm
from leaflet.forms.widgets import LeafletWidget

from google_api.elevation import get_elevation
from .models import POIModel, RouteModel, TrackModel


class POIForm(ModelForm):
    class Meta:
        model = POIModel
        fields = ['name', 'description', 'tags', 'public', 'geom']
        widgets = {'geom': LeafletWidget()}

    def clean_geom(self):
        return Point(*get_elevation(self.cleaned_data['geom']))


class RouteForm(ModelForm):
    class Meta:
        model = RouteModel
        fields = ['name', 'description', 'tags', 'public', 'geom']
        widgets = {'geom': LeafletWidget()}

    def clean_geom(self):
        return LineString(*get_elevation(self.cleaned_data['geom']))


class TrackForm(ModelForm):
    class Meta:
        model = TrackModel
        fields = ['name', 'description', 'tags', 'public', 'geom']
        geom = LeafletWidget()
        geom.modifiable = False
        widgets = {'geom': geom}

map/views.py
import json

from django.contrib.auth.decorators import login_required
from django.core.serializers import serialize
from django.http import HttpResponseForbidden, JsonResponse, HttpResponseRedirect, HttpResponse
from django.shortcuts import render, get_object_or_404
from django.urls import reverse
from django.utils.decorators import method_decorator
from django.views import View

from profile.models import ProfileModel
from story.models import StoryModel
from .forms import POIForm, RouteForm, TrackForm
from .models import TrackModel, POIModel, RouteModel


@method_decorator(login_required, name='dispatch')
class MapView(View):
    @staticmethod
    def get(request, username=None):
        if not username or username == request.user:
            profile = get_object_or_404(ProfileModel, user=request.user)
        else:
            profile = get_object_or_404(ProfileModel, user__username=username)
        return render(request, 'map.html', {
            'title': 'Map',
            'active': 'map',
            'profile': profile
        })


@method_decorator(login_required, name='dispatch')
class POIView(View):
    @staticmethod
    def get(request, id):
        poi = get_object_or_404(POIModel, id=id)
        if (poi.user == request.user or poi.public) and poi.is_active:
            return render(request, 'poi.html', {'title': poi.name, 'poi': poi})
        return HttpResponseForbidden()


@method_decorator(login_required, name='dispatch')
class RouteView(View):
    @staticmethod
    def get(request, id):
        route = get_object_or_404(RouteModel, id=id)
        if (route.user == request.user or route.public) and route.is_active:
            return render(request, 'route.html', {'title': route.name, 'route': route})
        return HttpResponseForbidden()


@method_decorator(login_required, name='dispatch')
class TrackView(View):
    @staticmethod
    def get(request, id):
        track = get_object_or_404(TrackModel, id=id)
        if (track.user == request.user or track.public) and track.is_active:
            return render(request, 'track.html', {'title': track.name, 'track': track})
        return HttpResponseForbidden()


@method_decorator(login_required, name='dispatch')
class POIEditView(View):
    @staticmethod
    def get(request, id=None):
        poi = get_object_or_404(POIModel, id=id) if id else None
        if poi and poi.user != request.user and poi.is_active:
            return HttpResponseForbidden()
        form = POIForm(instance=poi)
        return render(request, 'editor.html', {'title': poi.name if poi else 'New POI', 'form': form})

    @staticmethod
    def post(request, id=None):
        form = POIForm(request.POST)
        if form.is_valid():
            if id:                                                  # update POI
                poi = get_object_or_404(POIModel, id=id)
                poi.name = form.cleaned_data['name']
                poi.description = form.cleaned_data['description']
                poi.geom = form.cleaned_data['geom']
                poi.tags.set(*form.cleaned_data['tags'])
                poi.public = form.cleaned_data['public']
            else:                                                   # create POI
                poi = form.save(commit=False)
                poi.user = request.user
            poi.save()
            form.save_m2m() if not id else None
            return HttpResponseRedirect(reverse('table:view'))
        return render(request, 'editor.html', {'title': form['name'].value(), 'form': form})


@method_decorator(login_required, name='dispatch')
class RouteEditView(View):
    @staticmethod
    def get(request, id=None):
        route = get_object_or_404(RouteModel, id=id) if id else None
        if route and route.user != request.user and route.is_active:
            return HttpResponseForbidden()
        form = RouteForm(instance=route)
        return render(request, 'editor.html', {'title': route.name if route else 'New route', 'form': form})

    @staticmethod
    def post(request, id=None):
        form = RouteForm(request.POST)
        if form.is_valid():
            if id:                                                  # update route
                route = get_object_or_404(RouteModel, id=id)
                route.name = form.cleaned_data['name']
                route.description = form.cleaned_data['description']
                route.geom = form.cleaned_data['geom']
                route.tags.set(*form.cleaned_data['tags'])
                route.public = form.cleaned_data['public']
            else:
                route = form.save(commit=False)
                route.user = request.user
            route.length = form.cleaned_data['geom'].length * 100
            # Calculate min, max, loss, gain altitude
            alts = [i[2] for i in form.cleaned_data['geom']]
            diffs = [alts[i] - alts[i-1] for i in range(1, len(alts))]
            gain, loss = [i for i in diffs if i > 0], [-i for i in diffs if i < 0]
            #
            route.altitude_max = max(alts)
            route.altitude_min = min(alts)
            route.altitude_gain = sum(gain)
            route.altitude_loss = sum(loss)
            #
            route.save()
            form.save_m2m() if not id else None
            return HttpResponseRedirect(reverse('table:view'))
        return render(request, 'editor.html', {'title': form['name'].value(), 'form': form})


@method_decorator(login_required, name='dispatch')
class TrackEditView(View):
    @staticmethod
    def get(request, id=None):
        track = get_object_or_404(TrackModel, id=id) if id else None
        if not track or track.user != request.user and track.is_active:
            return HttpResponseForbidden()
        form = TrackForm(instance=track)
        return render(request, 'editor.html', {'title': track.name, 'form': form})

    @staticmethod
    def post(request, id=None):
        form = TrackForm(request.POST)
        if form.is_valid():
            track = get_object_or_404(TrackModel, id=id)
            track.name = form.cleaned_data['name']
            track.description = form.cleaned_data['description']
            track.tags.set(*form.cleaned_data['tags'])
            track.public = form.cleaned_data['public']
            track.save()
            return HttpResponseRedirect(reverse('table:view'))
        return render(request, 'editor.html', {'title': form['name'].value(), 'form': form})


@method_decorator(login_required, name='dispatch')
class JSONFeatureIdsView(View):
    @staticmethod
    def get(request, model):
        objs = model.objects.filter(user=request.user, is_active=True)
        return JsonResponse([obj.id for obj in objs], safe=False)


@method_decorator(login_required, name='dispatch')
class JSONFeatureView(View):
    @staticmethod
    def get(request, id, model):
        obj = get_object_or_404(model, id=id)
        if (obj.user == request.user or obj.public) and obj.is_active:
            data = serialize('geojson', [obj], geometry_field='geom')
            return JsonResponse(data, safe=False)
        return HttpResponseForbidden()


@method_decorator(login_required, name='dispatch')
class JSONFeaturesView(View):
    @staticmethod
    def get(request, model):
        objs = model.objects.filter(user=request.user, is_active=True)
        data = serialize('geojson', objs, geometry_field='geom')
        return JsonResponse(data, safe=False)


@method_decorator(login_required, name='dispatch')
class JSONFeatureChangeStatusView(View):
    @staticmethod
    def post(request, id, model):
        obj = get_object_or_404(model, id=id)
        if obj.user == request.user and obj.is_active:
            obj.public = not obj.public
            obj.save()
            return JsonResponse({'Status': 'OK'})
        return HttpResponseForbidden()


@method_decorator(login_required, name='dispatch')
class JSONFeatureDeleteView(View):
    @staticmethod
    def post(request, id, model):
        obj = get_object_or_404(model, id=id)
        if obj.user == request.user and not obj.public and obj.is_active:
            obj.is_active = False
            obj.save()
            return JsonResponse({'Status': 'OK'})
        return HttpResponseForbidden()


@method_decorator(login_required, name='dispatch')
class JSONFeatureHasStory(View):
    @staticmethod
    def get(request, id, model):
        obj = get_object_or_404(model, id=id)
        if obj.user == request.user and obj.is_active:
            return HttpResponse(json.dumps({
                'result': bool(StoryModel.objects.filter(track=obj))
            }), content_type='application/json')
        return HttpResponseForbidden()


@method_decorator(login_required, name='dispatch')
class JSONFeatureClearStory(View):
    @staticmethod
    def post(request, id, model):
        obj = get_object_or_404(model, id=id)
        if obj.user == request.user and obj.is_active:
            stories = StoryModel.objects.filter(track=obj)
            for story in stories:
                story.track = None
                story.save()
            return JsonResponse({'Status': 'OK'})
        return HttpResponseForbidden()

map/templates/editor.html
{% extends "base/base.html" %}
{% load bootstrap4 %}
{% load leaflet_tags %}
{% load staticfiles %}

{% block content %}
<form action="" method="post" class="form">
    {% csrf_token %}
    <div class="row">
        <div class="col-md-3" id="info">
            {% bootstrap_form_errors form %}
            {% bootstrap_field form.name show_label=False %}
            {% bootstrap_field form.description show_label=False %}
            {% bootstrap_field form.tags show_label=False %}
            {% bootstrap_field form.public show_label=False %}
            <div class="col-12 form-group text-center">
                {% bootstrap_button 'Save' button_type='submit' button_class='btn-success' %}
            </div>
        </div>
        <div class="col-md-9" id="map">
            {% bootstrap_field form.geom show_label=False %}
        </div>
    </div>
</form>
{% endblock %}

{% block css %}
    {% leaflet_css plugins="forms" %}
    <link href="{% static 'css/map-editor.css' %}" rel="stylesheet">
{% endblock %}

{% block js %}
    {% leaflet_js plugins="forms" %}
    <script src="{% static 'js/map-editor.js' %}"></script>
{% endblock %}

map/templates/map.html
{% extends "base/base_fullscreen.html" %}
{% load leaflet_tags %}
{% load staticfiles %}

{% block content %}
{% csrf_token %}
{% leaflet_map "mainmap" callback="window.map_init_basic" %}
{% endblock %}

{% block css %}
{% leaflet_css %}
<link href="{% static 'css/map.css' %}" rel="stylesheet" media="screen">
{% endblock %}

{% block js %}
{% leaflet_js %}
<script>
    var bounds;
    var progress = -1;

    var url_track_ids    = "{% url 'track:json_ids' %}",
        url_track_json   = "{% url 'track:json' id=0 %}",
        url_track_view   = "{% url 'track:view' id=0 %}",
        url_track_edit   = "{% url 'track:edit' id=0 %}",
        url_track_delete = "{% url 'track:json_delete' id=0 %}";

    var url_route_ids    = "{% url 'route:json_ids' %}",
        url_route_json   = "{% url 'route:json' id=0 %}",
        url_route_view   = "{% url 'route:view' id=0 %}",
        url_route_edit   = "{% url 'route:edit' id=0 %}",
        url_route_delete = "{% url 'route:json_delete' id=0 %}";

    var url_poi_ids    = "{% url 'poi:json_ids' %}",
        url_poi_json   = "{% url 'poi:json' id=0 %}",
        url_poi_view   = "{% url 'poi:view' id=0 %}",
        url_poi_edit   = "{% url 'poi:edit' id=0 %}",
        url_poi_delete = "{% url 'poi:json_delete' id=0 %}";
</script>
<script src="{% static 'js/map.js' %}"></script>
{% endblock %}

map/templates/poi.html
{% extends "base/base.html" %}
{% load bootstrap4 %}
{% load leaflet_tags %}
{% load taggit_templatetags2_tags %}
{% load staticfiles %}

{% block content %}
<div class="row">
    <div class="col-md-3 card text-white bg-dark" id="info">
        <div class="card-body">
            <div class="card-title text-center" id="feature_name">
                {{ poi.name }}
                <a href="{% url 'poi:edit' id=poi.pk%}" class="fa fa-edit"></a>
            </div>
            <div class="card-title text-center">
                {% get_tags_for_object poi as "tags" %}
                {% for tag in tags %}
                <small><a href="{% url 'tag:tag' tag.slug %}" class="badge badge-pill badge-secondary">{{ tag }}</a></small>
                {% endfor %}
            </div>
            <div class="card-text">
                {{ poi.description|default:'' }}
            </div>
            <div class="card-text">
                <div class="row">
                    <div class="card text-white bg-success text-center col-12">
                        <small>Longitude:</small>
                        {{ poi.longitude|floatformat:5 }}
                    </div>
                </div>
                <div class="row">
                    <div class="card text-white bg-success text-center col-12">
                        <small>Altitude:</small>
                        {{ poi.altitude|floatformat:5 }}
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="col-md-9">
        {% leaflet_map "mainmap" callback="window.map_init_basic" %}
    </div>
</div>
{% endblock %}

{% block css %}
    {% leaflet_css %}
    <link href="{% static 'css/feature-viewer.css' %}" rel="stylesheet">
{% endblock %}

{% block js %}
    {% leaflet_js %}
    <script>
        var url_poi = "{% url 'poi:json' poi.id %}";
    </script>
    <script src="{% static 'js/poi.js' %}"></script>
{% endblock %}

map/templates/route.html
{% extends "base/base.html" %}
{% load bootstrap4 %}
{% load leaflet_tags %}
{% load taggit_templatetags2_tags %}
{% load staticfiles %}

{% block content %}
<div class="row">
    <div class="col-md-3 card text-white bg-dark" id="info">
        <div class="card-body">
            <div class="card-title text-center" id="feature_name">
                {{ route.name }}
                <a href="{% url 'route:edit' id=route.pk%}" class="fa fa-edit"></a>
            </div>
            <div class="card-title text-center">
                {% get_tags_for_object route as "tags" %}
                {% for tag in tags %}
                <small><a href="{% url 'tag:tag' tag.slug %}" class="badge badge-pill badge-secondary">{{ tag }}</a></small>
                {% endfor %}
            </div>
            <div class="card-text">
                {{ route.description|default:'' }}
            </div>
            <div class="card-text">
                <div class="row">
                    <div class="card text-white bg-success text-center col-12">
                        <small>Distance:</small>
                        {{ route.length|floatformat|default:'-' }} km
                    </div>
                </div>
                <div class="row">
                    <div class="card text-white bg-success text-center col-6">
                        <small>Altitude gain:</small>
                        {{ route.altitude_gain|floatformat|default:'-' }} m
                    </div>
                    <div class="card text-white bg-success text-center col-6">
                        <small>Max altitude:</small>
                        {{ route.altitude_max|floatformat|default:'-' }} m
                    </div>
                </div>
                <div class="row">
                    <div class="card text-white bg-success text-center col-6">
                        <small>Altitude loss:</small>
                        {{ route.altitude_loss|floatformat|default:'-' }} m
                    </div>
                    <div class="card text-white bg-success text-center col-6">
                        <small>Min altitude:</small>
                        {{ route.altitude_min|floatformat|default:'-' }} m
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="col-md-9">
        {% leaflet_map "mainmap" callback="window.map_init_basic" %}
    </div>
</div>
{% endblock %}

{% block css %}
    {% leaflet_css plugins='elevation' %}
    <link href="{% static 'css/feature-viewer.css' %}" rel="stylesheet">
{% endblock %}

{% block js %}
    {% leaflet_js plugins='elevation' %}
    <script>
        var url_route = "{% url 'route:json' route.id %}";
    </script>
    <script src="{% static 'js/route.js' %}"></script>
{% endblock %}

map/templates/track.html
{% extends "base/base.html" %}
{% load bootstrap4 %}
{% load leaflet_tags %}
{% load taggit_templatetags2_tags %}
{% load staticfiles %}

{% block content %}
<div class="row">
    <div class="col-md-3 card text-white bg-dark" id="info">
        <div class="card-body">
            <div class="card-title text-center" id="feature_name">
                {{ track.name }}
                <a href="{% url 'track:edit' id=track.pk%}" class="fa fa-edit"></a>
            </div>
            <div class="card-title text-center">
                {% get_tags_for_object track as "tags" %}
                {% for tag in tags %}
                <a href="{% url 'tag:tag' tag.slug %}" class="badge badge-pill badge-secondary">{{ tag }}</a>
                {% endfor %}
            </div>
            <div class="card-text">
                {{ track.description|default:'' }}
            </div>
            <div class="card-text">
                <div class="row">
                    <div class="card text-white bg-success text-center col-12">
                        <small>Distance:</small>
                        {{ track.length|floatformat|default:'-' }} km
                    </div>
                </div>
                <div class="row">
                    <div class="card text-white bg-success text-center col-6">
                        <small>Avg. speed:</small>
                        {{ track.speed|floatformat|default:'-' }} km/h
                    </div>
                    <div class="card text-white bg-success text-center col-6">
                        <small>Max speed:</small>
                        {{ track.speed_max|floatformat|default:'-' }} km/h
                    </div>
                </div>
                <div class="row">
                    <div class="card text-white bg-success text-center col-6">
                        <small>Altitude gain:</small>
                        {{ track.altitude_gain|floatformat|default:'-' }} m
                    </div>
                    <div class="card text-white bg-success text-center col-6">
                        <small>Altitude loss:</small>
                        {{ track.altitude_loss|floatformat|default:'-' }} m
                    </div>
                </div>
                <div class="row">
                    <div class="card text-white bg-success text-center col-6">
                        <small>Max altitude:</small>
                        {{ track.altitude_max|floatformat|default:'-' }} m
                    </div>
                    <div class="card text-white bg-success text-center col-6">
                        <small>Min altitude:</small>
                        {{ track.altitude_min|floatformat|default:'-' }} m
                    </div>
                </div>
                <div class="row">
                    <div class="card text-white bg-success text-center col-12">
                        <small>Start time:</small>
                        {{ track.start_date|date|default:'-' }} {{track.start_date|time|default:'-'}}
                    </div>
                </div>
                <div class="row">
                    <div class="card text-white bg-success text-center col-12">
                        <small>Finish time:</small>
                        {{ track.finish_date|date|default:'-' }} {{ track.finish_date|time|default:'' }}
                    </div>
                </div>
                <div class="row">
                    <div class="card text-white bg-success text-center col-12">
                        <small>Time:</small>
                        {{ track.start_date|timesince:track.finish_date }}
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="col-md-9">
        {% leaflet_map "mainmap" callback="window.map_init_basic" %}
    </div>
</div>
{% endblock %}

{% block css %}
    {% leaflet_css plugins='elevation' %}
    <link href="{% static 'css/feature-viewer.css' %}" rel="stylesheet">
{% endblock %}

{% block js %}
    {% leaflet_js plugins='elevation' %}
    <script>
        var url_track = "{% url 'track:json' track.id %}";
    </script>
    <script src="{% static 'js/track.js' %}"></script>
{% endblock %}